#define __CARDCLASSES_H
#ifndef MAXHANDSIZE
#	define MAXHANDSIZE 13
#endif

#ifndef DEFDISPLAYMODETYPE
#	define DEFDISPLAYMODETYPE
enum displaymodetype { none, ansi, opengl };
#endif
#define decksize 52
#define JACK 11
#define QUEEN 12
#define KING 13
#define ACE 1

enum suittype{ Spades, Hearts, Clubs, Diamonds, nosuit };

class cardtype{
    private:
	void displaysuit(void);
	void displayvalue(void);
    public:
	suittype suit;
	int pointvalue;
	int value;

	cardtype();
	void erase(void);
	void display(displaymodetype displaymode);
	void display(int y, int x);
	cardtype operator = (cardtype newcard);
	int operator != (cardtype testcard);
	int operator == (cardtype testcard);
};

class handtype{
    public:
	cardtype card[MAXHANDSIZE];
	int numcards;

	handtype();
	void erase(void);
	void display(displaymodetype displaymode);
	void display(int y, int x);
	int sum(void);
	handtype operator = (handtype newhand);
	cardtype operator += (cardtype newcard);
	void sort(void);
	void passcard(handtype *recipient, int cardindex);
	void removecard(int cardindex);
};

class decktype{
    public:
	cardtype card[decksize];
	int numcards;

	decktype();
	void shuffle(void);
	void display(displaymodetype displaymode);
	cardtype draw(int cutpos);
	cardtype operator += (cardtype addition);
	handtype operator += (handtype addition);
};
