/****
 * To give credit where due:
 * Much of the code in here for handling tcp sockets is directly copied/derived
 * from a tutorial found on http://www.cs.rpi.edu/courses/sysprog/sockets/sock.html
 * Unfortunately, I could not find a name to whom it should be accredited.  That
 * aside, it has changed sufficiently that it may not even be recognizable anyway.
****/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int connect_to_host(int argc, char *argv[]);
void disconnect_from_host(void);

int socket_file;

int main(int argc, char *argv[]){
	int done = 0, n;
	char buffer[256];
	
	if(connect_to_host(argc, argv)){
		while(!done){
			printf("Please enter the message: ");
			memset(buffer, 0, 256);
			fgets(buffer,255,stdin);
					
			n = write(socket_file,buffer,strlen(buffer));
			if (n < 0){
				fprintf(stderr, "Unable to write to socket.\n");
				exit(1);
			}else{
				memset(buffer, 0, 256);
				n = read(socket_file, buffer, 255);
				if(n < 0){ 
					fprintf(stderr, "Unable to read from socket.\n");
					exit(1);
				}else{
					printf("%s\n",buffer);
				}
			}
		}

		disconnect_from_host();
	}

	return 0;
}

void disconnect_from_host(void){
	close(socket_file);
}

int connect_to_host(int argc, char *argv[]){
	int success = 1;
	int portno;
	struct sockaddr_in serv_addr;
	struct hostent *server;


	if (argc < 3) {
		fprintf(stderr,"usage %s hostname port\n", argv[0]);
		success = 0;
	}else{
		portno = atoi(argv[2]);
		socket_file = socket(AF_INET, SOCK_STREAM, 0);

		if (socket_file < 0){
			fprintf(stderr, "Unable to open socket.\n");
			success = 0;
		}else{
			server = gethostbyname(argv[1]);

			if (server == NULL) {
				fprintf(stderr, "Unable to find host.\n");
				success = 0;
			}else{
				memset((void *)&serv_addr, 0, sizeof(serv_addr));
				serv_addr.sin_family = AF_INET;
				memcpy((char *)&serv_addr.sin_addr.s_addr, (char *)server->h_addr, server->h_length);
				serv_addr.sin_port = htons(portno);

				if (connect(socket_file, (const struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0){
					fprintf(stderr, "Unable to connect to host\n");
					success = 0;
				}
			}
		}
	}
	return success;
}
/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>

/*** Functon declarations ***/
int bind_port(int portnumber, struct sockaddr_in *serveraddress);
void *serve(void *arg);
int startserver(int argc, char *argv[]);

/*** global variables ***/
int socket_file;
struct sockaddr_in server_address, client_address;

/**** function definitions ****/
int main(int argc, char *argv[]){
	pthread_t server_thread[2];
	void *returnvalue[2];
	int n;

	if(!startserver(argc, argv)){
		for(n = 0; n < 2; n++){
			pthread_create(&server_thread[n], NULL, serve, NULL);
		}
		for(n = 0; n < 2; n++){
			pthread_join(server_thread[n], &returnvalue[n]);
		}
	}
	
	return 0;
}


int startserver(int argc, char *argv[]){
	if (argc < 2) {
		fprintf(stderr,"No port number provided\n");
		exit(1);
	}

	socket_file = socket(AF_INET, SOCK_STREAM, 0);
	if(socket_file < 0){
		fprintf(stderr, "Unable to open socket\n");
		exit(1);
	}

	if(bind_port(atoi(argv[1]), &server_address) < 0){
		fprintf(stderr, "Unable to bind socket\n");
		exit(1);
	}
	
	
	return 0; 
}

void *serve(void *arg){
	int newsocket_file, size, done = 0;
	char buffer[256];

	/**** wait for a connection ****/
	listen(socket_file,5);
	size = sizeof(client_address);
	newsocket_file = accept(socket_file, (struct sockaddr *) &client_address, &size);

	if(newsocket_file < 0){
		fprintf(stderr, "Error accepting connection\n");
		exit(1);
	}
	
	/**** have a connection, start service ****/
	while(!done){
		memset(buffer, 0, 256 * sizeof(char));
		if(read(newsocket_file, buffer, 255) < 0){
			fprintf(stderr, "Unable to read from socket\n");
			exit(1);
		}else{
			if(!strcmp(buffer, "quit\n")){
				done = 1;
			}
						
			printf("Here is the message: %s\n",buffer);
			if(write(newsocket_file,"I got your message",18) < 0){
				fprintf(stderr, "Unable to write to socket\n");
				exit(1);
			}
		}
	}
	return arg;
}

int bind_port(int portnumber, struct sockaddr_in *serveraddress){

	memset((void *)serveraddress, 0, sizeof(*serveraddress));
	serveraddress->sin_family = AF_INET;
	serveraddress->sin_addr.s_addr = INADDR_ANY;
	serveraddress->sin_port = htons(portnumber);

	return bind(socket_file, (struct sockaddr *)serveraddress, sizeof(*serveraddress));
}
