#include <unistd.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

void writemessage(char *message, ...){
	int inputpos, outputpos, n, outputsize;
	char *output, *sptr, temp[100];
	va_list argptr;


	/************** 
	First, generate a string of text given the arguments passed.
	**************/
	outputsize = strlen(message) * sizeof(char);
	output = (char *)malloc(outputsize);
	outputpos = 0;
	va_start(argptr, message);
	for(inputpos = 0; inputpos <= (int)strlen(message); inputpos++){
		if(message[inputpos] == '%'){
			inputpos++;
			switch(message[inputpos]){				
				case 'c': /*** single character ***/
			 		output[outputpos] = (char)va_arg(argptr, int);
					outputpos++;
				break;

				case 's': /*** string ***/
					sptr = va_arg(argptr, char *);
					n = strlen(sptr);
					if(n > 1){
						outputsize += n;
						realloc(output, outputsize * sizeof(char));
					}
					strcat(output, sptr);
					outputpos += n;
				break;

				case 'i':
					itoa(temp, va_arg(argptr, int), 10);
					n = strlen(temp);
					if(n > 1){
						outputsize += n;
						realloc(output, outputsize * sizeof(char));
					}
					strcat(output, temp);
					outputpos += n;
				break;

				default:
					output[outputpos] = message[inputpos];
					outputpos++;
			}
		}else{
			output[outputpos] = message[inputpos];
			outputpos++;
		}
	}
	va_end(argptr);

	/********************
	OK, That was the tricky part.  Now simply display the text in
	whatever manner is appropriate.
	********************/

	write(stdout, output, outputsize * sizeof(char);
	free(output);
}

int main(void){
	writemessage("Hello World!\n");
	return 0;
}

